/****************************************************************************/

#include "nfi.h"

/****************************************************************************/

// This is the message dispatching class for the about dialog box
class CAboutDialogDispatcher : public CDispatcher {
public:
    CAboutDialogDispatcher (handlerType Handler) : CDispatcher (Handler) {}

    LRESULT MsgInit (HWND, UINT, WPARAM, LPARAM);
    LRESULT CmdDone (HWND, WORD, WORD, HWND);

MESSAGE_LIST;
COMMAND_LIST;
};

START_MESSAGE_LIST (CAboutDialogDispatcher)
    MESSAGE (WM_INITDIALOG , MsgInit)
END_MESSAGE_LIST

START_COMMAND_LIST (CAboutDialogDispatcher)
    COMMAND (IDOK     , CmdDone)
    COMMAND (IDCANCEL , CmdDone)
END_COMMAND_LIST

/****************************************************************************/

static CAboutDialogDispatcher DialogDispatch (handlerNone);

/*****************************************************************************
 * Name         - AboutProc
 * Purpose      - This handles messages for the about dialog box by using it's
 *                dispatcher class.
 * Arguments    - Standard window procedure dialog boxes
 * Return Value - Depends on the message
 ****************************************************************************/
LRESULT CALLBACK AboutProc (HWND hDlg , UINT uMessage ,
                            WPARAM wParam, LPARAM lParam)
{
 return DialogDispatch.dispatchMessage (hDlg , uMessage , wParam , lParam);
}

/*****************************************************************************
 * Name         - CAboutDialogDispatcher::MsgInit
 * Purpose      - This handles the WM_INITDIALOG message.
 * Arguments    - hDlg: Handle of the dialog box
 * Return Value - TRUE
 ****************************************************************************/
LRESULT CAboutDialogDispatcher::MsgInit (HWND hDlg , UINT /*uMessage*/ ,
                                         WPARAM /*wParam*/ , LPARAM /*lParam*/)
{
 // Tell the button to use the bitmap we loaded.
 SendMessage (GetDlgItem (hDlg , IDOK) , BM_SETIMAGE , (WPARAM) IMAGE_BITMAP , (LPARAM) hOKBitmap);

 // Center the dialog over the application window
 CenterWindow (hDlg , GetWindow (hDlg , GW_OWNER));

 return TRUE;
}

/*****************************************************************************
 * Name         - CAboutDialogDispatcher::CmdDone
 * Purpose      - This function handles command messages for the button and
 *                the standard windows close controls.
 * Arguments    - hDlg: Handle of the dialog box
 * Return Value - TRUE
 ****************************************************************************/
LRESULT CAboutDialogDispatcher::CmdDone (HWND hDlg, WORD wCommand,
                                         WORD /*wNotify*/, HWND /*hwndCtrl*/)
{
 // End the dialog
 EndDialog (hDlg , wCommand);
 return TRUE;
}

/****************************************************************************/

